<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.code')" prop="code">
        <el-input v-model="formData.code" :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderCode')" />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.name')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderName')" />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.remark')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderRemark')" />
      </el-form-item>
      <el-form-item :label="t('EquipmentManagement.EquipmentClassification.sort')" prop="sort">
        <el-input v-model="formData.sort" :placeholder="t('EquipmentManagement.EquipmentClassification.placeholderSort')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DeviceTypeApi, DeviceTypeTreeVO, DeviceTypeVO } from '@/api/mes/devicetype'

/** 设备类型 表单 */
defineOptions({ name: 'DeviceTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  remark: undefined,
  sort: undefined,
  parentId: undefined
})
const formRules = reactive({
  code: [{ required: true, message: '编码不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, parentRow?: DeviceTypeTreeVO) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()

  if (type === 'create') {
    formData.value.parentId = parentRow?.id ?? 0
  }
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DeviceTypeApi.getDeviceType(id)
      if (formData.value.parentId === undefined) {
        formData.value.parentId = parentRow?.parentId ?? 0
      }
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as DeviceTypeVO
    if (formType.value === 'create') {
      await DeviceTypeApi.createDeviceType(data)
      message.success(t('common.createSuccess'))
    } else {
      await DeviceTypeApi.updateDeviceType(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    remark: undefined,
    sort: undefined,
    parentId: undefined
  }
  formRef.value?.resetFields()
}
</script>
